<template>
  <at-table
    @load="loadData"
    :data="data"
    :page-result="pageResult"
    ref="AtTable"
    :dialogTitle="dialogTitle"
    :dialogVisible="dialogVisible"
    @select-all="handleSelect"
    @select="handleSelect"
    @handleDialogCancel="handleDialogCancel"
    @handleDialogClose="handleDialogClose"
    @handleDialogSubmit="handleDialogSubmit"
    @row-dblclick="handleRowDBClick"
  >
    <template v-slot:searchInput>
      <el-form
        ref="searchForm"
        :model="searchForm"
        label-width="80px"
        class="search-top"
        @submit.native.prevent
      >
        <project-info-selector
          v-if="isShow"
          v-model="searchForm.projectId"
          style="width: 100%"
          @keyup.enter.native="findinfo"
        ></project-info-selector>
        <el-input
          v-model="searchForm.qualityCode"
          style="width: 100%"
          placeholder="请输入巡检编号"
          clearable
          @keyup.enter.native="findinfo"
        ></el-input>
        <el-input
          v-model="searchForm.qualityInspectPosition"
          style="width: 100%"
          placeholder="请输入检查部位"
          clearable
          @keyup.enter.native="findinfo"
        ></el-input>
        <el-button
          size="small"
          @click="findinfo"
          type="primary"
          class="el-icon-search search-btn"
          >查询</el-button
        >
        <el-button
          size="small"
          @click="handleReset"
          type="primary"
          plain
          class="el-icon-refresh"
          >重置</el-button
        >
      </el-form>
    </template>
    <template v-slot:operationBtn>
      <el-button
        size="small"
        type="primary"
        @click="handleAdd"
        icon="el-icon-plus"
        >添加</el-button
      >
      <ht-delete-button
        :url="deleteUrl"
        :requestMethod="'POST'"
        :htTable="$refs.AtTable"
        >删除</ht-delete-button
      >
      <import-file :importData="importData" @load="load"></import-file>
      <el-button
        size="small"
        type="primary"
        @click="handleExport"
        icon="el-icon-download"
        plain
        style="margin-left: 10px"
        >导出</el-button
      >
    </template>
    <template>
      <el-table-column type="selection" width="55" align="center">
      </el-table-column>
      <el-table-column type="index" label="序号" width="55" align="center">
      </el-table-column>
      <el-table-column
        prop="projectInfo.projectName"
        label="项目名称"
        :show-overflow-tooltip="true"
        align="center"
      >
      </el-table-column>

      <el-table-column
        prop="qualityCode"
        label="巡检编号"
        align="center"
        :show-overflow-tooltip="true"
      >
      </el-table-column>
      <el-table-column
        prop="qualityUserName"
        label="质检员姓名"
        align="center"
        :show-overflow-tooltip="true"
      >
      </el-table-column>
      <!-- <el-table-column
        prop="createCompanyName"
        label="创建人单位名称"
        align="center"
        width="120"
        :show-overflow-tooltip="true"
      >
      </el-table-column> -->
      <!-- <el-table-column
        prop="createName"
        label="创建人姓名"
        align="center"
        width="100"
        :show-overflow-tooltip="true"
      >
      </el-table-column> -->
      <!-- <el-table-column
        prop="createOrgName"
        label="创建人组织名称"
        align="center"
        width="130"
        :show-overflow-tooltip="true"
      >
      </el-table-column> 
      <el-table-column
        prop="preventionMeasures"
        label="纠正预防措施"
        align="center"
        min-width="120"
        :show-overflow-tooltip="true"
      >
      </el-table-column>-->
      <el-table-column
        prop="qualityInspectPosition"
        label="检查部位"
        align="center"
        :show-overflow-tooltip="true"
      >
      </el-table-column>
       <el-table-column
        prop="checkSituation"
        label="检查情况"
        align="center"
        :show-overflow-tooltip="true"
      >
      </el-table-column>
      <el-table-column
        prop="establishmentRemarks"
        label="备注"
        align="center"
        width="100"
        :show-overflow-tooltip="true"
      >
      </el-table-column>
    </template>
    <template v-slot:dialogContent>
      <el-form
        ref="form"
        v-form
        data-vv-scope="form"
        :model="form"
        :rules="rules"
        label-width="130px"
        v-if="dialogVisible"
        v-loading.fullscreen="loading"
      >
        <el-row>
          <el-col :span="12">
            <el-form-item label="项目名称" prop="projectInfo.projectName">
              <el-input
                v-model="form.projectInfo.projectName"
                placeholder="请选择项目名称"
                @focus="handleFocusProject"
                :disabled="!isShow"
                clearable
              >
                <el-button
                  type="primary"
                  @click="openProject"
                  slot="append"
                  icon="el-icon-search"
                ></el-button>
              </el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="巡检编号" prop="qualityCode">
              <el-input
                v-model="form.qualityCode"
                placeholder="由后台返回"
                disabled
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="质检员姓名" prop="qualityUserName">
              <eip-user-selector
                :appendToBody="true"
                :placeholder="'请选择用户'"
                ref="eipSelector"
                v-model="form.qualityUserName"
                single
                permission="b"
                :config="{
                  id: 'form.qualityUserId',
                  name: 'form.qualityUserName',
                }"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="检查部位" prop="qualityInspectPosition">
              <el-input
                v-model="form.qualityInspectPosition"
                placeholder="请输入检查部位"
              >
              </el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item label="纠正预防措施" prop="preventionMeasures">
              <el-input
                v-model="form.preventionMeasures"
                placeholder="请输入纠正预防措施"
                type="textarea"
                clearable
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item label="检查情况" prop="checkSituation">
              <el-input
                v-model="form.checkSituation"
                placeholder="请输入检查情况"
                type="textarea"
                clearable
              />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item label="备注" prop="establishmentRemarks">
              <el-input
                v-model="form.establishmentRemarks"
                placeholder="请输入备注"
                type="textarea"
                clearable
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <file-table @handleFile="handleFile" :file="form.accessoryInfo" :info='"上传质量巡检记录文件"' />
        <project-info-dialog
          ref="project"
          :single="true"
          @select="handleSelectProject"
        ></project-info-dialog>
      </el-form>
    </template>
  </at-table>
</template>

<script>
const eipUserSelector = () =>
  import('@/components/selector/EipUserSelector.vue')
import req from '@/request.js'
import ProjectInfoDialog from '@/components/dialog/ProjectInfoDialog.vue'
export default {
  name: 'QualityInspection',
  components: {
    ProjectInfoDialog,
    eipUserSelector,
  },
  props: {
    pid: {
      type: String,
      default: '',
    },
    isShow: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      importData: {
        title: '质量巡检',
        templateName: '质量巡检模板.xls',
        downloadUrl: '/../fvue/static/excel/ExportQualityInspection.xlsx',
        importUrl:
          window.context.cqxy +
          '/biz/processManagement/qualityInspection/v1/importExcelData',
          showProject:true,
        projectId: '',
        // params: {
        //   qualityUserId: '',
        //   qualityUserName: '',
        // },
      },
      projectObj: [],
      loading: false,
      searchForm: {
        projectId: '',
        qualityUserName: '',
        qualityInspectPosition: '',
        qualityCode: '',
      }, //顶部搜索参数
      data: [], //表格数据
      pageResult: {
        page: 1,
        pageSize: 20,
        total: 0,
      },
      form: {},
      dialogVisible: false,
      dialogTitle: '添加',
      indexArr: [],
      querySearch: [],
      rules: {
        'projectInfo.projectName': {
          required: true,
          message: '请选择项目名称',
          trigger: 'blur',
        },
        'projectInfo.projectCode': {
          required: true,
          message: '请选择项目代码',
          trigger: 'blur',
        },
        // checkSituation: {
        //   required: true,
        //   message: '请输入检查情况',
        //   trigger: 'blur',
        // },
        // preventionMeasures: {
        //   required: true,
        //   message: '请输入纠正预防措施',
        //   trigger: 'blur',
        // },
        qualityInspectPosition: {
          required: true,
          message: '请输入检查部位',
          trigger: 'blur',
        },
        qualityUserName: {
          required: true,
          message: '请输入质检员姓名',
          trigger: 'blur',
        },
      },
    }
  },
  computed: {
    deleteUrl: function () {
      return (
        window.context.cqxy +
        '/biz/processManagement/qualityInspection/v1/delete'
      )
    },
  },
  mounted() {
    this.initProjectAll()
  },
  methods: {
    //重置
    handleReset() {
      this.searchForm.projectId = ''
      this.searchForm.qualityUserName = ''
      this.searchForm.qualityInspectPosition = ''
      this.searchForm.qualityCode = ''
      this.$refs['searchForm'].resetFields()
       this.pageResult={
        page:1,
        pageSize:20,
        total:0
      }
      this.$nextTick(()=>{
        this.$refs.AtTable.load()
      })
    },
    //导入后重新加载数据
    load() {
      this.$refs.AtTable.load()
    },
    //导出
    handleExport() {
      let query = []
      let search = {
        'pm.ID_': this.searchForm.projectId,
        'bqi.quality_user_name_': this.searchForm.qualityUserName,
        'bqi.quality_inspect_position_': this.searchForm.qualityInspectPosition,
        'bqi.quality_code_': this.searchForm.qualityCode,
      }
      if (!this.isShow) {
        search['pm.ID_'] = this.pid
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i],
          })
        }
      }
      let param = {
        pageBean: {
          page: 1,
          pageSize: -1,
          showTotal: true,
        },

        querys: query,
        sorter: [],
      }
      req
        .downloadPostCopy(
          '${cqxy}/biz/processManagement/qualityInspection/v1/exportDataToExcel',
          param
        )
        .then((res) => {
          if (res.status === 200) {
            this.$message.success('导出成功')
          } else {
            this.$message.error('导出失败')
          }
        })
    },
    handleFile(file) {
      this.form.accessoryInfo = file
    },
    handleAdd() {
      this.dialogTitle = '添加'
      this.form = {
        name: '',
        code: '',
        projectInfo: {
          projectName: '',
          projectCode: '',
        },
        accessoryInfo: [],
      }
      this.dialogVisible = true
      if (this.isShow) {
        let selectedProject = this.projectObj.find((item) => {
          if (item.currentProject && item.currentProject == 1) {
            return item.currentProject == 1
          }
        })

        this.form.projectInfo.projectName = selectedProject.projectName
        this.form.projectInfo.projectCode = selectedProject.projectCode
        this.form.projectId = selectedProject.id
      } else {
        //根据项目id查询
        this.form.projectInfo.projectName = this.projectObj[0].projectName
        this.form.projectInfo.projectCode = this.projectObj[0].projectCode
        this.form.projectId = this.projectObj[0].id
      }
    },
    handleRowDBClick(data) {
      this.dialogTitle = '修改'
      this.form = data
      this.dialogVisible = true
    },
    handleFocusProject() {
      this.$refs.project.open()
    },
    openProject() {
      this.$refs.project.open()
    },
    handleSelectProject(data) {
      this.form.projectId = data.id
      this.form.projectInfo.projectCode = data.projectCode
      this.form.projectInfo.projectName = data.projectName
      this.$refs.form.clearValidate()
    },
    handleSelect(selection) {},
    handleDialogCancel() {
      this.dialogVisible = false
    },
    handleDialogClose() {
      this.dialogVisible = false
    },
    initProjectAll() {
      //初始获取所有项目数据
      if (this.isShow) {
        this.$http.post('${cqxy}/biz/projectManagement/pm/v1/All').then(
          (res) => {
            this.projectObj = res.data.value
          },
          (error) => {
            reject(error)
          }
        )
      } else {
        let params = {
          pageBean: {
            page: 1,
            pageSize: 500,
            total: 0,
          },
          querys: [
            {
              group: 'main',
              operation: 'EQUAL',
              property: 'id',
              relation: 'AND',
              value: this.pid,
            },
          ],
        }
        this.$http
          .post('${cqxy}/biz/projectManagement/pm/v1/page', params)
          .then((res) => {
            if (res.data.state) {
              let resp = res.data.value
              this.projectObj = resp.rows
            }
          })
      }
    },
    //提交保存
    handleDialogSubmit() {
      this.$refs.form.validate((valid) => {
        if (valid && this.form.accessoryInfo.length !== 0) {
          this.form.accessoryInfo.forEach((item) => {
            if (item.id) {
              delete item.id
            }
          })
          this.loading = true
          this.$http
            .post(
              '${cqxy}/biz/processManagement/qualityInspection/v1/save',
              this.form
            )
            .then((res) => {
              if (res.data.state) {
                this.$refs.form.resetFields()
                this.$message.success(res.data.message)
                this.dialogVisible = false
                this.$refs.AtTable.load()
              } else {
                this.$message.error(res.data.message)
              }
              this.loading = false
            })
        } else if (this.form.accessoryInfo.length === 0) {
          this.$message.error('请至少上传一个附件')
        } else {
          this.$message({
            message: '*号必填项,不能为空!',
            type: 'warning',
          })
          return false
        }
      })
    },
    loadData(param, cb) {
      let query = []
      let search = {
        'pm.ID_': this.searchForm.projectId,
        'bqi.quality_user_name_': this.searchForm.qualityUserName,
        'bqi.quality_inspect_position_': this.searchForm.qualityInspectPosition,
        'bqi.quality_code_': this.searchForm.qualityCode,
      }
      this.searchObj = search
      if (!this.isShow) {
        search['pm.ID_'] = this.pid
        this.importData.projectId = this.pid
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i],
          })
        }
      }
        if (param.querys && param.querys.length) {
          param.querys.push(...query)
        } else {
          param.querys = query
        }

      this.$http
        .post('${cqxy}/biz/processManagement/qualityInspection/v1/page', param)
        .then(
          (resp) => {
            let response = resp.data.value
            this.data = response.rows
            this.pageResult = {
              page: response.page,
              pageSize: response.pageSize,
              total: response.total,
            }
          },
          (error) => {
            reject(error)
          }
        )
        .finally(() => cb())
    },
    findinfo() {
     this.$refs.AtTable.load()
    },
  },
}
</script>
<style lang="scss" scoped>
@import '@/assets/css/common.scss';
/deep/ .el-range-editor--small .el-range-separator {
  display: contents;
}
</style>
